/*
 * ReportGenerator.java
 *
 * Created on March 24, 2008, 8:13 PM
 */

package hsbs_gui;


import com.lowagie.text.*;
import com.lowagie.text.pdf.*;
import java.awt.Color;
import java.sql.*;
import java.awt.Point;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JSpinner;
import javax.swing.SpinnerDateModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;


/**
 *
 * @author  serdar
 */
public class ReportGenerator extends javax.swing.JPanel {
    
    
    
    
    
    /** Creates new form ReportGenerator */
    public ReportGenerator() {
   
            try {
                Calendar cal = Calendar.getInstance();
                java.util.Date now = cal.getTime();
                cal.add(Calendar.YEAR, -50);
                java.util.Date startDate = cal.getTime();
                cal.add(Calendar.YEAR, 100);
                java.util.Date endDate = cal.getTime();

                spinModel2 = new SpinnerDateModel(now, startDate, endDate, Calendar.MINUTE);
                cal = Calendar.getInstance();
                cal.add(Calendar.MINUTE,-15);
                java.util.Date now_minus15 = cal.getTime();
                spinModel1 = new SpinnerDateModel(now_minus15, startDate, endDate, Calendar.MINUTE);

                
                initComponents();
                
                JSpinner.DateEditor ds= new JSpinner.DateEditor(startSpinner,"dd/MM/yyyy H:mm:ss");
                startSpinner.setEditor(ds);



                JSpinner.DateEditor de= new JSpinner.DateEditor(endSpinner,"dd/MM/yyyy H:mm:ss");
                endSpinner.setEditor(de);

                
                
                ResultSet rslt1;
                //ResultSet rslt2;

                rslt1 = baglanti.returnQueryResult("SELECT * " + "from Sensors");

                Color a[] = {Color.ORANGE,Color.RED,Color.GREEN,Color.BLUE,Color.CYAN,Color.YELLOW}; 
                int i_color = 0;
                
                while (rslt1.next()) {
                String nodeName = "Node " + rslt1.getInt("SensorID");
                JCheckBox tmp = new  JCheckBox(nodeName, false);
                checkBoxNodeV.add(tmp);
                
                if (i_color > 5)
                    i_color=0;
               
                //System.out.println(tmp.toString());
                tmp.setVisible(true);
                tmp.addActionListener(new java.awt.event.ActionListener() {
                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                jCheckBoxNodeActionPerformed(evt);
                            }
                        }); 
                tmp.setBackground(Color.WHITE);
                solMenuPanel.add(tmp);
                //tmp.getIcon().paintIcon(this, new G, 10, 10);
                i_color++;
                }
    
                

                //con.close();
            } catch (Exception e) {
                e.printStackTrace();
            }

            
            
            editorPane.setContentType("text/html");    
        
    }

    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        includePane = new javax.swing.JPanel();
        humCheckBox = new javax.swing.JCheckBox();
        tempCheckBox = new javax.swing.JCheckBox();
        graphCheckBox = new javax.swing.JCheckBox();
        commentCheckBox = new javax.swing.JCheckBox();
        pathTextField = new javax.swing.JTextField();
        browseButton = new javax.swing.JButton();
        saveAsComboBox = new javax.swing.JComboBox();
        saveLabel = new javax.swing.JLabel();
        pathLabel = new javax.swing.JLabel();
        editPane = new javax.swing.JScrollPane();
        editorPane = new javax.swing.JEditorPane();
        genButton = new javax.swing.JButton();
        clearButton = new javax.swing.JButton();
        saveButton = new javax.swing.JButton();
        fileNameTextField = new javax.swing.JTextField();
        fileLabel = new javax.swing.JLabel();
        editLabel = new javax.swing.JLabel();
        startLabel = new javax.swing.JLabel();
        startSpinner = new javax.swing.JSpinner(spinModel1);
        endLabel = new javax.swing.JLabel();
        endSpinner = new javax.swing.JSpinner(spinModel2);
        solMenuPanel = new javax.swing.JPanel();

        includePane.setBorder(javax.swing.BorderFactory.createTitledBorder("Include"));
        includePane.setToolTipText("Include");
        includePane.setName("Include"); // NOI18N

        humCheckBox.setSelected(true);
        humCheckBox.setText("Humidity");
        humCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                humCheckBoxActionPerformed(evt);
            }
        });

        tempCheckBox.setSelected(true);
        tempCheckBox.setText("Temperature");

        graphCheckBox.setSelected(true);
        graphCheckBox.setText("Graphs");

        commentCheckBox.setSelected(true);
        commentCheckBox.setText("Comments");

        org.jdesktop.layout.GroupLayout includePaneLayout = new org.jdesktop.layout.GroupLayout(includePane);
        includePane.setLayout(includePaneLayout);
        includePaneLayout.setHorizontalGroup(
            includePaneLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(includePaneLayout.createSequentialGroup()
                .addContainerGap()
                .add(includePaneLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tempCheckBox)
                    .add(graphCheckBox)
                    .add(commentCheckBox)
                    .add(humCheckBox))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        includePaneLayout.setVerticalGroup(
            includePaneLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(includePaneLayout.createSequentialGroup()
                .add(humCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tempCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(graphCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(commentCheckBox))
        );

        pathTextField.setText("/home/serdar/reports");
        pathTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pathTextFieldActionPerformed(evt);
            }
        });

        browseButton.setText("Browse");
        browseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseButtonActionPerformed(evt);
            }
        });

        saveAsComboBox.setBackground(new java.awt.Color(255, 255, 255));
        saveAsComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Adobe PDF (pdf)", "Plain Text (txt)" }));

        saveLabel.setText("Save as:");

        pathLabel.setText("Path:");

        editPane.setViewportView(editorPane);

        genButton.setText("Generate");
        genButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                genButtonActionPerformed(evt);
            }
        });

        clearButton.setText("Clear");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        fileNameTextField.setText("untitled");

        fileLabel.setText("File Name:");

        editLabel.setText("Edit:");

        startLabel.setText("From");

        endLabel.setText("To");

        solMenuPanel.setBackground(new java.awt.Color(255, 255, 255));
        solMenuPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(genButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(saveButton))
                    .add(clearButton)
                    .add(solMenuPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 119, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(startLabel)
                    .add(startSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 155, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(endSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 155, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(endLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(includePane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(saveLabel)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(layout.createSequentialGroup()
                                        .add(fileLabel)
                                        .add(101, 101, 101))
                                    .add(layout.createSequentialGroup()
                                        .add(fileNameTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 143, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(pathLabel)
                                    .add(layout.createSequentialGroup()
                                        .add(pathTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 206, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(browseButton))))
                            .add(saveAsComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 428, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(56, 56, 56))
                    .add(editLabel)
                    .add(layout.createSequentialGroup()
                        .add(editPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 615, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(22, 22, 22)
                        .add(saveLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(saveAsComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(12, 12, 12)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(pathLabel)
                            .add(layout.createSequentialGroup()
                                .add(15, 15, 15)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(pathTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(fileNameTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(browseButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(solMenuPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 162, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(startLabel))
                            .add(layout.createSequentialGroup()
                                .add(includePane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(44, 44, 44)
                                .add(editLabel))
                            .add(layout.createSequentialGroup()
                                .add(65, 65, 65)
                                .add(fileLabel)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(startSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(endLabel)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(endSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(125, 125, 125)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(genButton)
                                    .add(saveButton))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(clearButton))
                            .add(editPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 251, Short.MAX_VALUE))))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void humCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_humCheckBoxActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_humCheckBoxActionPerformed

    private void browseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseButtonActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
        int result = fileChooser.showDialog(this, "Open");
        if (result == JFileChooser.APPROVE_OPTION) {
            File file = fileChooser.getSelectedFile();
            pathTextField.setText(file.toString());
        }
}//GEN-LAST:event_browseButtonActionPerformed

    private void pathTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pathTextFieldActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_pathTextFieldActionPerformed
    private void jCheckBoxNodeActionPerformed(java.awt.event.ActionEvent evt) {
        //drawButtonActionPerformed(evt);
    }
    
    private void genButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_genButtonActionPerformed
        try {
           
            Calendar cal = Calendar.getInstance();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");

            theText = new ArrayList<String>();
            String st = "";
            String tmps = "HSBS Soft Generated Report: " + sdf.format(cal.getTime());
            tmps = tmps + "<br>\nThe data aqcuired between " + (java.util.Date)startSpinner.getValue() + " and " + (java.util.Date)endSpinner.getValue();
            theText.add(tmps);
            st = st + tmps;
            
      
            ResultSet rs;
            ResultSet rslt1;
            ResultSet rslt2;

            java.util.Date fromDate = (java.util.Date) startSpinner.getValue();
            java.util.Date toDate = (java.util.Date) endSpinner.getValue();
            
            rs = baglanti.returnQueryResult("SELECT * " +
                    "from Sensors");

            String sfds = "SELECT SensorID sid, AVG( Hval ) c FROM Humidity WHERE UNIX_TIMESTAMP(Humidity.Time) > "+ (fromDate.getTime()/1000)+" AND UNIX_TIMESTAMP(Humidity.Time) < " +(toDate.getTime()/1000) + " GROUP BY sid";    
            rslt1 = baglanti2.returnQueryResult(sfds);
            
            String afds = "SELECT SensorID sid, AVG( Tval ) c FROM Temperature WHERE UNIX_TIMESTAMP(Temperature.Time) > "+ (fromDate.getTime()/1000) + " AND UNIX_TIMESTAMP(Temperature.Time) < " + (toDate.getTime()/1000) + " GROUP BY sid";
            rslt2 = baglanti3.returnQueryResult(afds);
            
            
             for (int i =0; rs.next() && i<checkBoxNodeV.size()  ; i++ ) {
                if (!checkBoxNodeV.get(i).isSelected())
                    continue;
                    tmps = "<br>\nSensor ID: " + rs.getInt("SensorID") +
                           "<br>\nLocation: " + rs.getString("Location") + 
                           "<br>\nIP Address: " + rs.getString("LastIP");
                    if (rslt1.next())
                        tmps = tmps + "\nAverage Humidity: "+rslt1.getFloat("c");
                    if (rslt2.next())
                        tmps = tmps + "\nAverage Temperature: "+rslt2.getFloat("c");
                    
                    theText.add(tmps);
                    st = st + "\n<br>" + tmps;
             }
            
           
            editorPane.setText(st);//GEN-LAST:event_genButtonActionPerformed
            /*
            private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
                // TODO add your handling code here:
            }//GEN-LAST:event_clearButtonActionPerformed

private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_saveButtonActionPerformed
            */
        } catch (SQLException ex) {
            Logger.getLogger(ReportGenerator.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
        
    }
    
    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {
            editorPane.setText("");
    }
    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {
        try{
            if (saveAsComboBox.getSelectedIndex() == 1){
                String fileName = pathTextField.getText() +"/" + fileNameTextField.getText() +".txt";    
                FileWriter fw = new FileWriter(fileName);
                PrintWriter pw = new PrintWriter(fw);
                pw.print(editorPane.getText());
                pw.close();
                System.out.println(fileName);
            }
            else if (saveAsComboBox.getSelectedIndex() == 0){
                String fileName = pathTextField.getText() +"/" + fileNameTextField.getText() + ".pdf";
                PdfWriter pdfW = PdfWriter.getInstance(document, new FileOutputStream(fileName));
                document.open();
                document.add(new Paragraph(editorPane.getText()));
                
                document.close();
            }
            
         
        
        } catch (DocumentException ex) {
            Logger.getLogger(ReportGenerator.class.getName()).log(Level.SEVERE, null, ex);
        }catch (IOException e){
            e.printStackTrace();
           
        }    
            
      
            
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton browseButton;
    private javax.swing.JButton clearButton;
    private javax.swing.JCheckBox commentCheckBox;
    private javax.swing.JLabel editLabel;
    private javax.swing.JScrollPane editPane;
    private javax.swing.JEditorPane editorPane;
    private javax.swing.JLabel endLabel;
    private javax.swing.JSpinner endSpinner;
    private javax.swing.JLabel fileLabel;
    private javax.swing.JTextField fileNameTextField;
    private javax.swing.JButton genButton;
    private javax.swing.JCheckBox graphCheckBox;
    private javax.swing.JCheckBox humCheckBox;
    private javax.swing.JPanel includePane;
    private javax.swing.JLabel pathLabel;
    private javax.swing.JTextField pathTextField;
    private javax.swing.JComboBox saveAsComboBox;
    private javax.swing.JButton saveButton;
    private javax.swing.JLabel saveLabel;
    private javax.swing.JPanel solMenuPanel;
    private javax.swing.JLabel startLabel;
    private javax.swing.JSpinner startSpinner;
    private javax.swing.JCheckBox tempCheckBox;
    // End of variables declaration//GEN-END:variables
    private DefaultMutableTreeNode root = new DefaultMutableTreeNode();
    private Point p;
    private TreePath tpath;
    private Document document = new Document(PageSize.A4, 50, 50, 50, 50);
    private ArrayList<String> theText;
    SpinnerDateModel spinModel1,spinModel2;
    dbConnection baglanti = new dbConnection();
    dbConnection baglanti2 = new dbConnection();
    dbConnection baglanti3 = new dbConnection();
    Vector <JCheckBox> checkBoxNodeV = new Vector<JCheckBox>();
}
